FIC.nam = 
function(Y,X,Z,W1=NULL,W2=NULL,focus="E(Y|x,z)",protected,unprotected,varmatrix)
{
  # Y = response vector
  # X = regression variables that are present in all models, always included, explicitly include an intercept
  # if you want one to be present.
  # Z = regression variables to be used in the variable selection method 
  
 #sanity.check.FIC.lnam(Y,X,Z,W1,W2,focus,protected,unprotected,varmatrix)

 nn = nrow(as.matrix(X))
 
  Rho1=Rho2=NULL
  if(!is.null(W1)&!is.null(W2)){mle=lnam(Y,cbind(X,Z),W1,W2)
  Rho1=mle$rho1
  Rho2=mle$rho2
  J=mle$infomat
  colnames(J)=rownames(J)=c(colnames(cbind(X,Z)),"Rho1","Rho2","SigSq")
  all.estimated=c(mle$beta,mle$rho1,mle$rho2,mle$sigma^2)
  names(all.estimated)=colnames(J)
  }  
  if(!is.null(W1)&is.null(W2)){mle=lnam(Y,cbind(X,Z),W1=W1)
  Rho1=mle$rho1
  J=mle$infomat
  colnames(J)=rownames(J)=c(colnames(cbind(X,Z)),"Rho1","SigSq")
  all.estimated=c(mle$beta,mle$rho1,mle$sigma^2)
  names(all.estimated)=colnames(J)
  }
  if(is.null(W1)&!is.null(W2)){mle=lnam(Y,cbind(X,Z),W2=W2)
  Rho2=mle$rho2
  J=mle$infomat
  colnames(J)=rownames(J)=c(colnames(cbind(X,Z)),"Rho2","SigSq")
  all.estimated=c(mle$beta,mle$rho2,mle$sigma^2)
  names(all.estimated)=colnames(J)
  }
  if(is.null(W1)&is.null(W2)){mle=lnam(Y,cbind(X,Z))
  J=mle$infomat
  colnames(J)=rownames(J)=c(colnames(cbind(X,Z)),"SigSq")
  all.estimated=c(mle$beta,mle$sigma^2)
  names(all.estimated)=colnames(J)
  }
  

  which.of.protected	= protected[which(protected%in%colnames(J))]
  which.of.unprotected	= unprotected[which(unprotected%in%colnames(J))]
   
  
  J00=J[which.of.protected,which.of.protected]
  J11=J[which.of.unprotected,which.of.unprotected]
  J10=J[which.of.unprotected,which.of.protected]
  J01=J[which.of.protected,which.of.unprotected]
  betagamma.hat=all.estimated[which.of.unprotected]
  deltahat = nn^{1/2}*betagamma.hat
  
  invJ = solve(J)
  Q <- invJ[which.of.unprotected,which.of.unprotected]
  
func2 		= function(Rho1) {solve(diag(rep(1,nrow(W1)))-Rho1*W1)%*%cbind(X,Z)%*%mle$beta}
func21 		= function(Rho2) {solve(diag(rep(1,nrow(W1)))-Rho1*W1)%*%cbind(X,Z)%*%mle$beta}
func3 		= function(Betas){solve(diag(rep(1,nrow(W1)))-Rho1*W1)%*%cbind(X,Z)%*%Betas}

func2_b 		= function(Rho1) {solve(diag(rep(1,nrow(W1)))-Rho1*W1)%*%cbind(X,Z)%*%mle$beta-cbind(X,Z)%*%mle$beta}
func21_b 		= function(Rho2) {solve(diag(rep(1,nrow(W1)))-Rho1*W1)%*%cbind(X,Z)%*%mle$beta-cbind(X,Z)%*%mle$beta}
func3_b 		= function(Betas){solve(diag(rep(1,nrow(W1)))-Rho1*W1)%*%cbind(X,Z)%*%Betas-cbind(X,Z)%*%Betas}

func2_c 		= function(Rho1) {Rho2}
func21_c 		= function(Rho2) {Rho2} 
func3_c 		= function(Betas){Rho2}

  
if (focus=="E(Y|x,z)"){ 
if(!is.null(Rho1)& !is.null(Rho2)){
partmu.respect.rho1							= jacobian(func2, x=Rho1)
partmu.respect.beta							= jacobian(func3, x=mle$beta)
partmu.respect.sigsq						= rep(0,length(X))
partmu.respect.rho2							= jacobian(func21, x=Rho2)
PartialDerivMatrix			= cbind(partmu.respect.beta,partmu.respect.rho1,partmu.respect.rho2,partmu.respect.sigsq)
colnames(PartialDerivMatrix)	= colnames(J)
} 

if(is.null(Rho1)& is.null(Rho2)){
partmu.respect.beta							= jacobian(func3, x=mle$beta) 
partmu.respect.sigsq						= rep(0,length(X))
PartialDerivMatrix			= cbind(partmu.respect.beta,partmu.respect.sigsq)
colnames(PartialDerivMatrix)	= colnames(J)
} 

if(!is.null(Rho1)& is.null(Rho2)){
partmu.respect.rho1							= jacobian(func2, x=Rho1)
partmu.respect.beta							= jacobian(func3, x=mle$beta)
partmu.respect.sigsq						= rep(0,length(X))
PartialDerivMatrix			= cbind(partmu.respect.beta,partmu.respect.rho1,partmu.respect.sigsq)
colnames(PartialDerivMatrix)	= colnames(J)
} 

if(is.null(Rho1)& !is.null(Rho2)){
partmu.respect.beta							= jacobian(func3, x=mle$beta)
partmu.respect.sigsq						= rep(0,length(X))
partmu.respect.rho2							= jacobian(func21, x=Rho2)
PartialDerivMatrix			= cbind(partmu.respect.beta,partmu.respect.rho2,partmu.respect.sigsq)
colnames(PartialDerivMatrix)	= colnames(J)
} 
}

if (focus=="Rho1"){
if(is.null(Rho1)) {stop("Rho1 needs to be in the model since it is also focus")} 
if(!is.null(Rho1)& !is.null(Rho2)){
partmu.respect.rho1							= jacobian(func2_b, x=Rho1)
partmu.respect.beta							= jacobian(func3_b, x=mle$beta)
partmu.respect.sigsq						= 0
partmu.respect.rho2							= jacobian(func21_b, x=Rho2)
PartialDerivMatrix							= cbind(partmu.respect.beta,partmu.respect.rho1,partmu.respect.rho2,partmu.respect.sigsq)
colnames(PartialDerivMatrix)				= colnames(J)
} 

if(!is.null(Rho1)& is.null(Rho2)){
partmu.respect.rho1							= jacobian(func2_b, x=Rho1)
partmu.respect.beta							= jacobian(func3_b, x=mle$beta)
partmu.respect.sigsq						= 0
PartialDerivMatrix							= cbind(partmu.respect.beta,partmu.respect.rho1,partmu.respect.sigsq)
colnames(PartialDerivMatrix)				= colnames(J)
} 
} 

if (focus=="Rho2"){
if(is.null(Rho2)) {stop("Rho2 needs to be in the model since it is also focus")} 
if(!is.null(Rho1)& !is.null(Rho2)){
partmu.respect.rho1							= jacobian(func2_b, x=Rho1)
partmu.respect.beta							= jacobian(func3_b, x=mle$beta)
partmu.respect.sigsq						= 0
partmu.respect.rho2							= jacobian(func21_b, x=Rho2)
PartialDerivMatrix							= cbind(partmu.respect.beta,partmu.respect.rho1,partmu.respect.rho2,partmu.respect.sigsq)
colnames(PartialDerivMatrix)				= colnames(J)
} 

if(!is.null(Rho2)& is.null(Rho1)){
partmu.respect.rho2							= jacobian(func2_b, x=Rho2)
partmu.respect.beta							= jacobian(func3_b, x=mle$beta)
partmu.respect.sigsq						= 0
PartialDerivMatrix							= cbind(partmu.respect.beta,partmu.respect.rho2,partmu.respect.sigsq)
colnames(PartialDerivMatrix)				= colnames(J)
} 
}



if (focus=="Rho1/Rho2"){
if(is.null(Rho2)) {stop("Rho2 needs to be in the model since it is also focus")} 
if(!is.null(Rho1)& !is.null(Rho2)){
partmu.respect.rho1							= jacobian(func2_c, x=Rho1)
partmu.respect.beta							= jacobian(func3_c, x=mle$beta)
partmu.respect.sigsq						= 0
partmu.respect.rho2							= jacobian(func21_c, x=Rho2)
PartialDerivMatrix							= cbind(partmu.respect.beta,partmu.respect.rho1,partmu.respect.rho2,partmu.respect.sigsq)
colnames(PartialDerivMatrix)				= colnames(J)
} 
} 

funct<-function(k){
      res<-apply(varmatrix,1,FUN=function(x){FIC(focus,k,PartialDerivMatrix,J00,J10,x,Q,omega,deltahat,which.of.protected,which.of.unprotected)})
      FIC.S<-unlist(sapply(res,"[",1))
	  MSE.S<-unlist(sapply(res,"[",2))
	  bias.S<-unlist(sapply(res,"[",3))
	  bias2.S<-unlist(sapply(res,"[",4))
	  var2.S<-unlist(sapply(res,"[",5))

return(list(FIC.S,MSE.S,bias.S,bias2.S,var2.S))}

 
FIC = function(focus,k,PartialDerivMatrix=NULL,J00,J10,variables,Q,omega,deltahat,which.of.protected,which.of.unprotected)
  {
	variables=variables[which.of.unprotected]
	#print(k)
	if (focus=="E(Y|x,z)"|focus=="Rho1"|focus=="Rho2"|focus=="Rho1/Rho2")
	{
	partmutheta=PartialDerivMatrix[k,which.of.protected]
	partmugamma=PartialDerivMatrix[k,which.of.unprotected]
	tau0sq = crossprod(partmutheta,solve(J00)%*%partmutheta)
    omega = J10%*%solve(J00,partmutheta) - partmugamma
	} 
	
	
	if (sum(variables)>0)
      {
		qq = length(variables)
        indic = variables*(1:qq)

        Id 		= diag (rep(1,qq))
        pi.S 	= matrix(Id[indic,],ncol=qq)

        Q.S  	= solve(pi.S %*% solve(Q ,t(pi.S)))
		Q0.S 	= crossprod(pi.S, Q.S) %*% pi.S
        G.S  	= Q0.S %*% solve(Q)
  
		#bias2.S = max(t(omega)%*%(Id-G.S)%*%(tcrossprod(deltahat)-Q)%*%(Id-t(G.S))%*%omega,0) #PAGE 152
		#omega.S = pi.S %*% omega
        
		bias.S  = (t(omega)%*%(Id-G.S)%*%deltahat)		#PAGE 152
		bias2.S = bias.S^2
		var2.S  = tau0sq + crossprod(omega, Q0.S)%*%omega
		
		MSE.S   = var2.S + bias2.S	 #PAGE 152
		FIC.S	= MSE.S- (tau0sq-(crossprod(omega, Q)%*%omega))	#PAGE 152
		FIC.S	= t(omega)%*%(Id-G.S)%*%tcrossprod(deltahat)%*%(Id-t(G.S))%*%omega+2*crossprod(omega, Q0.S)%*%omega		
	   } else {
	FIC.S = crossprod(omega,deltahat)^2; #PAGE 147
	bias.S = crossprod(omega, deltahat);
	bias2.S = bias.S^2
	var2.S = tau0sq;
	MSE.S = var2.S+bias2.S; #PAGE 127
	}

    outputFIC=list(FIC.S,MSE.S,bias.S,bias2.S,var2.S)
    names(outputFIC)=c("FIC.S","MSE.S","bias.S","bias2.S","var2.S")
    return(outputFIC) 
  }
  
if (focus=="E(Y|x,z)"|focus=="Rho1"|focus=="Rho2"){
ll<-sapply(1:nn,FUN=funct)
FIC.subject.model=do.call(rbind,ll[1,])
MSE.subject.model=do.call(rbind,ll[2,])
bias.subject.model = do.call(rbind,ll[3,])
bias2.subject.model = do.call(rbind,ll[4,])
var.subject.model =  do.call(rbind,ll[5,])
} else {
ll<-funct(1)
FIC.subject.model=matrix(ll[[1]],nrow=1)
MSE.subject.model=matrix(ll[[2]],nrow=1)
bias.subject.model = matrix(ll[[3]],nrow=1)
bias2.subject.model = matrix(ll[[4]],nrow=1)
var.subject.model =  matrix(ll[[5]],nrow=1)
}
  

# print(sum(FIC.subject.model<0))
# print(sum(MSE.subject.model<0))
# print(sum(bias.subject.model<0))
# print(sum(bias2.subject.model<0))
# print(sum(var.subject.model<0))


colnms=paste("M",1:nrow(varmatrix),sep="")
colnames(FIC.subject.model)=colnms
colnames(MSE.subject.model)=colnms
colnames(bias.subject.model)=colnms
colnames(bias2.subject.model)=colnms
colnames(var.subject.model)=colnms

FIC.minima = apply(FIC.subject.model,1,which.min)
which.vars.selected = varmatrix[FIC.minima,]
return(list(FIC=FIC.subject.model,MSE=MSE.subject.model,Bias=bias.subject.model,Bias2=bias2.subject.model,
Var=var.subject.model, SelectedVars = which.vars.selected,
Delta=deltahat,Rho1=Rho1,Rho2=Rho2))
} 

FIC.nam.summary =
function(FICscores,varmatrix,focus)
{

  # Equal weight to all covariate combinations for model estimation
  FIC.eq.weighted = apply(FICscores,2,mean)

  print("Global model selection via FIC")
  print(paste("Focus =", focus))
  print("All subjects equal weight")
  print("")
  print("Parameters in the selected model:")
  print(varmatrix[which.min(FIC.eq.weighted),])

  print("Average FIC values for all models:")
  print(sort(FIC.eq.weighted))

  print("Model number:")
  print(which.min(FIC.eq.weighted))
  return(list(SelectedVars=varmatrix[which.min(FIC.eq.weighted),], Model=which.min(FIC.eq.weighted)))

}

allsubsets.varmatrix=function(unprotected){
		varmatrix=combinations(length(unprotected))
		colnms=paste("M",1:nrow(varmatrix),sep="")
		rownames(varmatrix)=colnms
		colnames(varmatrix)=unprotected	
		return(varmatrix)
		}		
nested.varmatrix=function(unprotected){
		id=diag(length(unprotected)); 
		id[lower.tri(id)]=1; 
		varmatrix=rbind(rep(0,length(unprotected)),id)		
		colnms=paste("M",1:nrow(varmatrix),sep="")
		rownames(varmatrix)=colnms
		colnames(varmatrix)=unprotected	
		return(varmatrix)
		}	
combinations = function(n){
  comb = NULL
  for( i in 1:n) comb = rbind(cbind(1,comb),cbind(0,comb))
  return(comb)
 }	
 		
	
# sanity.check.FIC.nam = 
# function(Y,X,Z,W1,W2,focus,protected,unprotected,varmatrix)
# {
    # if (missing(Y))
        # stop("Need to specify the dependent variable (vector form), i.e. Y")
		
	# if (missing(X))
        # stop("Need to specify some protected variables (matrix form), usually the at least the Intercept is protected")
	
	# if (is.null(dim(X)))	
		# stop("Need to specify X as a matrix")
	
	# if (is.null(dim(Z)))	
		# stop("Need to specify Z as a matrix")
	
	# if (dim(Z)[1]!=length(Y))
		# stop("Need to specify the same number of rows for Z as the length of Y")
	
	# if (is.null(W1)==F){
		# if (is.null(dim(W1))){	
			# stop("Need to specify W1 as a matrix")}}
	
	# if (is.null(W2)==F){
		# if (is.null(dim(W2))){	
			# stop("Need to specify W2 as a matrix")}}
			
	# if (is.null(dim(varmatrix)))	
		# stop("Need to specify varmatrix as a 1/0 (variable present/not present) matrix. \n See ?nested.varmatrix or ?allsubsets.varmatrix")
	
	# if (dim(varmatrix)[2]!=length(unprotected))
		# stop("Need to specify the same number of columns for the varmatrix as the number of elements in Unprotected")
	
	# if (length(protected)<1)
		# stop("Need to specify some protected parameters: all models should contain at least SigSq and Intercept")
	
	# if (length(protected)<2)
		# stop("No model selection is possible. Need to specify some more unprotected parameters to perform model selection")
	
	
	# if(any(protected%in%unprotected))
		# stop("The elements in Unprotected and Protected should be distinct")
	
	# if(!(focus%in%(c(protected,unprotected,"E(Y|x,z)"))))
		# stop(paste("The only focuses allowed are: ",paste(c(unprotected,protected,"E(Y|x,z)"),collapse=", "),sep=""))
	
	
	# if (dim(X)[2]>1){	
		# if (colnames(X)[1]!="Intercept" | any((X[,1]!=1)==T)){
			# stop("Need to specify a column of 1s as the first column and name it `Intercept'")}}
	# if (is.null(dim(X)))
        # stop("Need to specify the protected variables in matrix form")
	
	# if (!(min(varmatrix)%in%c(0,1))| !(max(varmatrix)%in%c(0,1)))
		# stop("Need to specify the elements of varmatrix as 0 (the variable is not present) or 1 (the variable is present). \n See ?nested.varmatrix or ?allsubsets.varmatrix")
		
	#if (is.null(W1)&is.null(W2))
     #  stop("Need to specify at least one form of dependency W1 (autoregressive effects) or W2 (moving average effects)")
	# if (is.null(W1)==F){
		# if (sum(dim(W1)==length(Y))!=2){ 
			# stop("Need to specify the same dimensions for W1 as the length of Y")}}
	# if (is.null(W2)==F){
		# if (sum(dim(W2)==length(Y))!=2){ 
			# stop("Need to specify the same dimensions for W2 as the length of Y")}}
	
	# if (is.null(dim(varmatrix))==F){
		# if(any((unprotected==colnames(varmatrix))==F)){
			# stop("Need to specify the same names for the varmatrix as the names of Z")}}
						
	# if(!("SigSq"%in%protected) | !("Intercept"%in%protected))
		# stop("The residual variance SigSq needs to be protected and present in all models")
	# if(any((protected %in% c(colnames(X),colnames(Z),"Rho1","Rho2","SigSq"))==F))
		# stop(paste("Need to specify allowed protected parameters. The possible protected parameters, any of: ",
		# paste(c(colnames(X),colnames(Z),"Rho1","Rho2","SigSq"),collapse=", "),sep=""))
	# if(any(table(c(protected))>1))
		# stop("Some of the parameters appear twice")	
	# TRUE
# }

	
  