
FIC.nrm= 
function(Y,X,Z,W2=NULL,focus="E(Y|x,z)",protected,unprotected,varmatrix,actor=1)
{
  # Y = response network
  # X = network that is present in all models, always included
  # Z = networks to be used in the variable selection method 
  
 if (focus=="E(Y|x,z)"){
   Y2 <- gvectorize(Y)
   X2 <- gvectorize(X)
   Z1=NULL
   for (i in 1:length(Z)) 
   Z1 <- cbind(Z1, gvectorize(Z[[i]]))
   Z2=Z1
   na.index=which(is.na(Y2))
   Z2=Z2[-na.index,]  
   X2=matrix(X2[-na.index,],ncol=1)
   Y2=matrix(Y2[-na.index,],ncol=1)
   colnames(Z2)=names(Z)
   colnames(X2)=names(X)
   nn = nrow(as.matrix(X2))
   W22=W2[-na.index,-na.index]
   colnames(X2)="Intercept"
   colnames(Z2)=names(Z)
   

  Rho2=NULL
  if(!is.null(W22)){mle=lnam(Y2,cbind(X2,Z2),W1=NULL,W2=W22)
  Rho2=mle$rho2
  J=mle$infomat
  colnames(J)=rownames(J)=c(colnames(cbind(X2,Z2)),"Rho2","SigSq")
  all.estimated=c(mle$beta,mle$rho2,mle$sigma^2)
  names(all.estimated)=colnames(J)
  }  
  if(is.null(W22)){mle=lnam(Y2,cbind(X2,Z2),W1=NULL,W2=NULL)
  J=mle$infomat
  colnames(J)=rownames(J)=c(colnames(cbind(X2,Z2)),"SigSq")
  all.estimated=c(mle$beta,mle$sigma^2)
  names(all.estimated)=colnames(J)
  }
  
  which.of.protected	= protected[which(protected%in%colnames(J))]
  which.of.unprotected	= unprotected[which(unprotected%in%colnames(J))]
   
  
  J00=J[which.of.protected,which.of.protected]
  J11=J[which.of.unprotected,which.of.unprotected]
  J10=J[which.of.unprotected,which.of.protected]
  J01=J[which.of.protected,which.of.unprotected]
  betagamma.hat=all.estimated[which.of.unprotected]
  deltahat = nn^{1/2}*betagamma.hat
  
  invJ = solve(J)
  Q <- invJ[which.of.unprotected,which.of.unprotected]
  
  
func21 		= function(Rho2) {cbind(X2,Z2)%*%mle$beta}
func3 		= function(Betas){cbind(X2,Z2)%*%Betas}


if (focus=="E(Y|x,z)"){ 
if(!is.null(Rho2)){
partmu.respect.beta							= jacobian(func3, x=mle$beta)
partmu.respect.sigsq						= rep(0,length(X2))
partmu.respect.rho2							= jacobian(func21, x=Rho2)
PartialDerivMatrix							= cbind(partmu.respect.beta,partmu.respect.rho2,partmu.respect.sigsq)
colnames(PartialDerivMatrix)				= colnames(J)
} 

if(is.null(Rho2)){
partmu.respect.beta							= jacobian(func3, x=mle$beta) 
partmu.respect.sigsq						= rep(0,length(X2))
PartialDerivMatrix							= cbind(partmu.respect.beta,partmu.respect.sigsq)
colnames(PartialDerivMatrix)				= colnames(J)
} 
}

funct<-function(k){
      res<-apply(varmatrix,1,FUN=function(x){FIC(focus,k,PartialDerivMatrix,J00,J10,x,Q,omega,deltahat,which.of.protected,which.of.unprotected)})
      FIC.S<-unlist(sapply(res,"[",1))
	  MSE.S<-unlist(sapply(res,"[",2))
	  bias.S<-unlist(sapply(res,"[",3))
	  bias2.S<-unlist(sapply(res,"[",4))
	  var2.S<-unlist(sapply(res,"[",5))

return(list(FIC.S,MSE.S,bias.S,bias2.S,var2.S))}

 
FIC = function(focus,k,PartialDerivMatrix=NULL,J00,J10,variables,Q,omega,deltahat,which.of.protected,which.of.unprotected)
  {
	variables=variables[which.of.unprotected]
	#print(k)
	if (focus=="E(Y|x,z)")
	{
	partmutheta=PartialDerivMatrix[k,which.of.protected]
	partmugamma=PartialDerivMatrix[k,which.of.unprotected]
	tau0sq = crossprod(partmutheta,solve(J00)%*%partmutheta)
    omega = J10%*%solve(J00,partmutheta) - partmugamma
	} 
	
	
	if (sum(variables)>0)
      {
		qq = length(variables)
        indic = variables*(1:qq)

        Id 		= diag (rep(1,qq))
        pi.S 	= matrix(Id[indic,],ncol=qq)

        Q.S  	= solve(pi.S %*% solve(Q ,t(pi.S)))
		Q0.S 	= crossprod(pi.S, Q.S) %*% pi.S
        G.S  	= Q0.S %*% solve(Q)
  
		#bias2.S = max(t(omega)%*%(Id-G.S)%*%(tcrossprod(deltahat)-Q)%*%(Id-t(G.S))%*%omega,0) #PAGE 152
		#omega.S = pi.S %*% omega
        
		bias.S  = (t(omega)%*%(Id-G.S)%*%deltahat)		#PAGE 152
		bias2.S = bias.S^2
		var2.S  = tau0sq + crossprod(omega, Q0.S)%*%omega
		
		MSE.S   = var2.S + bias2.S	 #PAGE 152
		FIC.S	= MSE.S- (tau0sq-(crossprod(omega, Q)%*%omega))	#PAGE 152
		FIC.S	= t(omega)%*%(Id-G.S)%*%tcrossprod(deltahat)%*%(Id-t(G.S))%*%omega+2*crossprod(omega, Q0.S)%*%omega		
	   } else {
	FIC.S = crossprod(omega,deltahat)^2; #PAGE 147
	bias.S = crossprod(omega, deltahat);
	bias2.S = bias.S^2
	var2.S = tau0sq;
	MSE.S = var2.S+bias2.S; #PAGE 127
	}

    outputFIC=list(FIC.S,MSE.S,bias.S,bias2.S,var2.S)
    names(outputFIC)=c("FIC.S","MSE.S","bias.S","bias2.S","var2.S")
    return(outputFIC) 
  }
  
if (focus=="E(Y|x,z)"){
ll<-sapply(1:nn,FUN=funct)
FIC.subject.model=do.call(rbind,ll[1,])
MSE.subject.model=do.call(rbind,ll[2,])
bias.subject.model = do.call(rbind,ll[3,])
bias2.subject.model = do.call(rbind,ll[4,])
var.subject.model =  do.call(rbind,ll[5,])
} 

  

# print(sum(FIC.subject.model<0))
# print(sum(MSE.subject.model<0))
# print(sum(bias.subject.model<0))
# print(sum(bias2.subject.model<0))
# print(sum(var.subject.model<0))


colnms=paste("M",1:nrow(varmatrix),sep="")
colnames(FIC.subject.model)=colnms
colnames(MSE.subject.model)=colnms
colnames(bias.subject.model)=colnms
colnames(bias2.subject.model)=colnms
colnames(var.subject.model)=colnms

FIC.minima = apply(FIC.subject.model,1,which.min)
which.vars.selected = varmatrix[FIC.minima,]
return(list(FIC=FIC.subject.model,MSE=MSE.subject.model,Bias=bias.subject.model,Bias2=bias2.subject.model,
Var=var.subject.model, SelectedVars = which.vars.selected,
Delta=deltahat,Rho2=Rho2,Prestige=NULL))
}
if (focus=="Prestige"){
   Y2 <- gvectorize(Y)
   X2 <- gvectorize(X)
   Z1=NULL
   for (i in 1:length(Z)) 
   Z1 <- cbind(Z1, gvectorize(Z[[i]]))
   Z2=Z1
   na.index=which(is.na(Y2))
   Z2=Z2[-na.index,]  
   X2=matrix(X2[-na.index,],ncol=1)
   Y2=matrix(Y2[-na.index,],ncol=1)
   colnames(Z2)=names(Z)
   colnames(X2)=names(X)
   nn = nrow(as.matrix(X2))
   W22=W2[-na.index,-na.index]
   colnames(X2)="Intercept"
   colnames(Z2)=names(Z)
   n=ncol(Y)
   

  Rho2=NULL
  if(!is.null(W22)){mle=lnam(Y2,cbind(X2,Z2),W1=NULL,W2=W22)
  Rho2=mle$rho2
  J=mle$infomat
  colnames(J)=rownames(J)=c(colnames(cbind(X2,Z2)),"Rho2","SigSq")
  all.estimated=c(mle$beta,mle$rho2,mle$sigma^2)
  names(all.estimated)=colnames(J)
  }  
  if(is.null(W22)){mle=lnam(Y2,cbind(X2,Z2),W1=NULL,W2=NULL)
  J=mle$infomat
  colnames(J)=rownames(J)=c(colnames(cbind(X2,Z2)),"SigSq")
  all.estimated=c(mle$beta,mle$sigma^2)
  names(all.estimated)=colnames(J)
  }
  
  which.of.protected	= protected[which(protected%in%colnames(J))]
  which.of.unprotected	= unprotected[which(unprotected%in%colnames(J))]
   
  
  J00=J[which.of.protected,which.of.protected]
  J11=J[which.of.unprotected,which.of.unprotected]
  J10=J[which.of.unprotected,which.of.protected]
  J01=J[which.of.protected,which.of.unprotected]
  betagamma.hat=all.estimated[which.of.unprotected]
  deltahat = nn^{1/2}*betagamma.hat
  
  invJ = solve(J)
  Q <- invJ[which.of.unprotected,which.of.unprotected]
  
  
func21 		= function(Rho2) {
  a=rep(0,n*n)
  b=c(cbind(X2,Z2)%*%mle$beta)
  for (i in 1:(length(na.index)-1)){a[(na.index[i]+1):(na.index[i+1]-1)]=b[1:n];b=b[-c(1:n)]}	
  Gr=matrix(a,n,n)
   return(infocent(Gr,gmode="graph"))
  }
  
func3 		= function(Betas){a=rep(0,n*n)
  b=c(cbind(X2,Z2)%*%Betas)
  for (i in 1:(length(na.index)-1)){a[(na.index[i]+1):(na.index[i+1]-1)]=b[1:n];b=b[-c(1:n)]}	
  Gr=matrix(a,n,n)
   return(infocent(Gr,gmode="graph"))
  }

if (focus=="Prestige"){ 
if(!is.null(Rho2)){
partmu.respect.beta							= jacobian(func3, x=mle$beta)
partmu.respect.sigsq						= rep(0,n)
partmu.respect.rho2							= jacobian(func21, x=Rho2)
PartialDerivMatrix							= matrix(c(partmu.respect.beta[actor,],partmu.respect.rho2[actor],partmu.respect.sigsq[actor]),nrow=1)
colnames(PartialDerivMatrix)				= colnames(J)
} 

if(is.null(Rho2)){
partmu.respect.beta							= jacobian(func3, x=mle$beta) 
partmu.respect.sigsq						= rep(0,n)
PartialDerivMatrix							= matrix(c(partmu.respect.beta[actor,],partmu.respect.sigsq[actor]),nrow=1)
colnames(PartialDerivMatrix)				= colnames(J)
} 
}

FIC = function(focus,PartialDerivMatrix=NULL,J00,J10,variables,Q,omega,deltahat,which.of.protected,which.of.unprotected)
  {
	variables=variables[which.of.unprotected]
	#print(k)
	if (focus=="Prestige")
	{
	partmutheta=PartialDerivMatrix[,which.of.protected]
	partmugamma=PartialDerivMatrix[,which.of.unprotected]
	tau0sq = crossprod(partmutheta,solve(J00)%*%partmutheta)
    omega = J10%*%solve(J00,partmutheta) - partmugamma
	} 
	
	
	if (sum(variables)>0)
      {
		qq = length(variables)
        indic = variables*(1:qq)

        Id 		= diag (rep(1,qq))
        pi.S 	= matrix(Id[indic,],ncol=qq)

        Q.S  	= solve(pi.S %*% solve(Q ,t(pi.S)))
		Q0.S 	= crossprod(pi.S, Q.S) %*% pi.S
        G.S  	= Q0.S %*% solve(Q)
  
		#bias2.S = max(t(omega)%*%(Id-G.S)%*%(tcrossprod(deltahat)-Q)%*%(Id-t(G.S))%*%omega,0) #PAGE 152
		#omega.S = pi.S %*% omega
        
		bias.S  = (t(omega)%*%(Id-G.S)%*%deltahat)		#PAGE 152
		bias2.S = bias.S^2
		var2.S  = tau0sq + crossprod(omega, Q0.S)%*%omega
		
		MSE.S   = var2.S + bias2.S	 #PAGE 152
		FIC.S	= MSE.S- (tau0sq-(crossprod(omega, Q)%*%omega))	#PAGE 152
		FIC.S	= t(omega)%*%(Id-G.S)%*%tcrossprod(deltahat)%*%(Id-t(G.S))%*%omega+2*crossprod(omega, Q0.S)%*%omega		
	   } else {
	FIC.S = crossprod(omega,deltahat)^2; #PAGE 147
	bias.S = crossprod(omega, deltahat);
	bias2.S = bias.S^2
	var2.S = tau0sq;
	MSE.S = var2.S+bias2.S; #PAGE 127
	}

    outputFIC=list(FIC.S,MSE.S,bias.S,bias2.S,var2.S)
    names(outputFIC)=c("FIC.S","MSE.S","bias.S","bias2.S","var2.S")
    return(outputFIC) 
  }
 
res<-apply(varmatrix,1,FUN=function(x){FIC(focus,PartialDerivMatrix,J00,J10,x,Q,omega,deltahat,which.of.protected,which.of.unprotected)})
 
if (focus=="Prestige"){
FIC.subject.model	= matrix(unlist(sapply(res,"[",1)),nrow=1)
MSE.subject.model	= matrix(unlist(sapply(res,"[",2)),nrow=1)
bias.subject.model 	= matrix(unlist(sapply(res,"[",3)),nrow=1)
bias2.subject.model = matrix(unlist(sapply(res,"[",4)),nrow=1)
var.subject.model 	= matrix(unlist(sapply(res,"[",5)),nrow=1)
} 

# print(sum(FIC.subject.model<0))
# print(sum(MSE.subject.model<0))
# print(sum(bias.subject.model<0))
# print(sum(bias2.subject.model<0))
# print(sum(var.subject.model<0))

colnms=paste("M",1:nrow(varmatrix),sep="")
colnames(FIC.subject.model)=colnms
colnames(MSE.subject.model)=colnms
colnames(bias.subject.model)=colnms
colnames(bias2.subject.model)=colnms
colnames(var.subject.model)=colnms

FIC.minima = apply(FIC.subject.model,1,which.min)
which.vars.selected = varmatrix[FIC.minima,]

mle=lnam(Y2,cbind(X2,Z2[,which(which.vars.selected!=0)]),W1=NULL,W2=W22)

  a=rep(0,n*n)
  b=c(cbind(X2,Z2)[,c(1,which(which.vars.selected!=0))]%*%mle$beta)
    b=c(cbind(X2,Z2[,which(which.vars.selected!=0)])%*%mle$beta)

  for (i in 1:(length(na.index)-1)){a[(na.index[i]+1):(na.index[i+1]-1)]=b[1:n];b=b[-c(1:n)]}	
  myGr=matrix(a,n,n)
estimated_prestige=infocent(myGr,gmode="graph")
  
return(list(FIC=FIC.subject.model,MSE=MSE.subject.model,Bias=bias.subject.model,Bias2=bias2.subject.model,
Var=var.subject.model, SelectedVars = which.vars.selected,
Delta=deltahat,Rho2=Rho2,Prestige=estimated_prestige))
}
} 


FIC.nrm.summary =
function(FICscores,varmatrix,focus)
{

  # Equal weight to all covariate combinations for model estimation
  FIC.eq.weighted = apply(FICscores,2,mean)

  print("Global model selection via FIC")
  print(paste("Focus =", focus))
  print("All subjects equal weight")
  print("")
  print("Parameters in the selected model:")
  print(varmatrix[which.min(FIC.eq.weighted),])

  print("Average FIC values for all models:")
  print(sort(FIC.eq.weighted))

  print("Model number:")
  print(which.min(FIC.eq.weighted))
  return(list(SelectedVars=varmatrix[which.min(FIC.eq.weighted),], Model=which.min(FIC.eq.weighted)))

}