\name{SocNetFIC-package}
\alias{SocNetFIC-package}
\docType{package}
\title{
Model selection with FIC for social network models
}
\description{
The package was developed to accompany the paper: "Pircalabelu, E. and Claeskens, G. (2016). Focused model selection for social networks. Social Networks.".  
Given a collection of models, the procedure estimates for each model the mean squared error of the estimator of the focus. 
The model with the smallest such value is selected. We present focused model selection for (i) exponential random graph models, 
(ii) network autocorrelation models and (iii) network regression models to investigate existing relations in social networks.}
\details{
\tabular{ll}{
Package: \tab SocNetFIC\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2015-11-23\cr
License: GPL-3 \cr
}
}
\author{
Eugen Pircalabelu <Eugen.Pircalabelu@kuleuven.be>
}
\references{
Pircalabelu, E. and Claeskens, G. (2016). Focused model selection for social networks. Social Networks. To appear.
}
~~ Optionally other standard keywords, one per line, from file KEYWORDS in the R documentation directory ~~
\keyword{ FIC, ERGM, SNA }

\seealso{\code{\link{FIC.ergm}}, \code{\link{FIC.nam}} and \code{\link{FIC.nrm}}}
